/*
 * Cheops Next Generation
 * 
 * Mark Spencer <markster@marko.net>
 *
 * Copyright(C) 1999, Adtran, Inc.
 * 
 * Distributed under the terms of the GNU General Public License (GPL) Version 2
 *
 * Error handling routines
 *
 */

#include <stdarg.h>
#include <stdio.h>
#include <netinet/in.h>
#include "logger.h"
#include "event.h"
#include "cerror.h"

void cheops_error(agent *a, u16 error, char *fmt, ...)
{
	static char buf[65536];
	static event_hdr *h = (event_hdr *)buf;
	static error_r *er = (error_r *)(buf + sizeof(event_hdr));
	static char *c = buf + sizeof(event_hdr) + sizeof(error_r);
	va_list ap;

		
	va_start(ap, fmt);
	vsnprintf(c, 
			  sizeof(buf) - sizeof(event_hdr) - sizeof(error_r), 
			  		fmt, ap);
	er->len = htons(strlen(c));
	er->error = htons(error);
	h->len = htonl(strlen(c) + sizeof(event_hdr) + sizeof(error_r));
	h->hlen = htons(sizeof(event_hdr));
	h->type = htons(REPLY_ERROR);
	h->flags = htonl(FLAG_IGNORE);
	if (event_send(a, h) < 0) 
		clog(LOG_DEBUG, "Unable to send error '%s'\n", c);
	va_end(ap);
}
