/*
 * Choeps Next Generation GUI
 * 
 * Brent Priddy <toopriddy@mailcity.com>
 *
 * Copyright(C) 1999, Adtran, Inc.
 * 
 * Distributed under the terms of the GNU General Public License (GPL) Version
 *
 * Functions for the gnome canvas and the page_object's that are on the canvas
 *
 */


#ifndef GUI_CANVAS_H
#define GUI_CANVAS_H

#include <gdk/gdk.h>
#include <gnome.h>
#include "cheops-gui.h"

/*
 * Create a new page_abject with all fields avaliable for use
 */
page_object	*page_object_new(GnomeCanvas *canvas);

/*
 * Display the page object, give it a pixmap, and put it on the canvas
 */
void	page_object_display( page_object *po );

/*
 * event function for the canvas (tidbit: the canvas event is called before the page items)
 */
int	net_page_event_dispatch(GtkObject *widget, GdkEvent *event, net_page *np);

/*
 * this highlights/unhighlights all of the oage_objects on a net_page (the highlight is TRUE or FALSE) 
 */
void	net_page_highlight_all(net_page *np, int highlight);

/*
 * delete all highlighted page_objects on a net_page (np can be NULL == use current page)
 */
void	net_page_delete_page_object(net_page *np);

/*
 * delete a single page_object on the net_page's canvas
 */
void	page_object_delete(net_page *np, page_object *po);

/*
 * Set up the plink adding all highlighted items on the current net_page
 */
void	net_page_set_plink(void);

/*
 * remove all plink's on the current net_page
 */
void	net_page_unset_plink(void);

/*
 * Callback for the menu delete selection (it creates a confirm dialog)
 */
void	delete_page_objects_popup_callback(GtkWidget *w,gpointer data);

/*
 * get a page object on the net_page
 */
page_object *page_object_get_pointer(net_page *np, char *name);


#endif /* GUI_CANVAS_H */