/*
 * Cheops Next Generation
 * 
 * Mark Spencer <markster@marko.net>
 *
 * Copyright(C) 1999, Adtran, Inc.
 * 
 * Distributed under the terms of the GNU General Public License (GPL) Version 2
 *
 * Logging routines
 *
 */

#include <stdarg.h>
#include <stdio.h>
#include "logger.h"

static char *levels[] = {
	"DEBUG",
	"NOTICE",
	"WARNING",
	"ERROR"
};

extern void clog(int level, char *file, int line, char *function, char *fmt, ...)
{
	va_list ap;
	va_start(ap, fmt);
	fprintf(stdout, "%s: File %s, Line %d (%s): ", levels[level], file, line, function);
	vfprintf(stdout, fmt, ap);
	va_end(ap);
}
