/*
 * Cheops Next Generation
 * 
 * Mark Spencer <markster@marko.net>
 *
 * Copyright(C) 1999, Adtran, Inc.
 * 
 * Distributed under the terms of the GNU General Public License (GPL) Version 2
 *
 * Test Scheduler Routines
 *
 */

#include "cheops.h"
#include "sched.h"
#include <stdio.h>

int hello(char *blah)
{
	fprintf(stderr, "%s:(once only)!\n", blah);
	return 0;
}

int hello2(char *blah)
{
	fprintf(stderr, "%s:(repeat)!\n", blah);
	return 1;
}

int main(int argc, char *argv[])
{
	int id;
	id = cheops_sched_add(1000, CHEOPS_SCHED_CB(hello2), "Hello World!");
	id = cheops_sched_add(5000, CHEOPS_SCHED_CB(hello), "Hello World!");
	id = cheops_sched_add(2000, CHEOPS_SCHED_CB(hello), "Hello World!");
	fprintf(stdout,"Scheduled event %d\n", id);
	cheops_sched_dump();
	cheops_main();
	return 0;
}
